"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var schematics_1 = require("@angular-devkit/schematics");
var workspace_1 = require("@schematics/angular/utility/workspace");
function updateNpmScript(tree, logger) {
    var _a;
    var pkgPath = '/package.json';
    var buffer = tree.read(pkgPath);
    if (buffer === null) {
        throw new schematics_1.SchematicsException('Could not read package.json');
    }
    var pkg = JSON.parse(buffer.toString());
    if (pkg === null || typeof pkg !== 'object' || Array.isArray(pkg)) {
        throw new schematics_1.SchematicsException('Error reading package.json');
    }
    if ((_a = pkg.scripts) === null || _a === void 0 ? void 0 : _a['extract-i18n-merge']) {
        logger.info('updating npm script "extract-i18n-merge" (you can delete it if you like!)..');
        pkg.scripts['extract-i18n-merge'] = 'ng extract-i18n';
    }
    tree.overwrite(pkgPath, JSON.stringify(pkg, null, 2));
}
function default_1() {
    return function (tree, context) {
        updateNpmScript(tree, context.logger);
        return (0, workspace_1.updateWorkspace)(function (workspace) {
            workspace.projects.forEach(function (project, projectName) {
                var _a, _b, _c;
                var i18nMergeTarget = project.targets.get('extract-i18n-merge');
                if (i18nMergeTarget) {
                    context.logger.info("updating extract-i18n(-merge) targets for project ".concat(projectName, ".."));
                    var i18nTarget = __assign({}, ((_a = project.targets.get('extract-i18n')) !== null && _a !== void 0 ? _a : { builder: 'ng-extract-i18n-merge:ng-extract-i18n-merge' }));
                    i18nTarget.builder = 'ng-extract-i18n-merge:ng-extract-i18n-merge';
                    i18nTarget.options = __assign(__assign({}, i18nMergeTarget.options), { browserTarget: (_c = (_b = i18nTarget.options) === null || _b === void 0 ? void 0 : _b.browserTarget) !== null && _c !== void 0 ? _c : "".concat(projectName, ":build") });
                    project.targets.delete('extract-i18n'); // 'project.targets.set' not working!?
                    project.targets.add(__assign({ name: 'extract-i18n' }, i18nTarget));
                    project.targets.delete('extract-i18n-merge');
                }
                else {
                    context.logger.warn('target "extract-i18n-merge" not found in workspace - please migrate manually!');
                }
            });
        });
    };
}
exports.default = default_1;
