"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var architect_1 = require("@angular-devkit/architect");
var core_1 = require("@angular-devkit/core");
var fs_1 = require("fs");
var fileUtils_1 = require("./fileUtils");
var lexUtils_1 = require("./lexUtils");
var translationFileSerialization_1 = require("./model/translationFileSerialization");
var translationFileModels_1 = require("./model/translationFileModels");
var merger_1 = require("./merger");
var stringUtils_1 = require("./stringUtils");
var STATE_INITIAL_XLF_2_0 = 'initial';
var STATE_INITIAL_XLF_1_2 = 'new';
var builder = (0, architect_1.createBuilder)(extractI18nMergeBuilder);
exports.default = builder;
/**
 * Sorts translation units of `updatedTranslationSourceFile` by the order of their appearance in `originalTranslationSourceFile` (returned as children of `translationUnitsParent`).
 * If an id is not found in `originalTranslationSourceFile`, it is returned in `newUnits`.
 */
function resetSortOrderStable(originalTranslationSourceFile, updatedTranslationSourceFile, idMapping) {
    var _a;
    var originalIdsOrder = (_a = originalTranslationSourceFile === null || originalTranslationSourceFile === void 0 ? void 0 : originalTranslationSourceFile.map(function (unit) { var _a; return (_a = idMapping[unit.id]) !== null && _a !== void 0 ? _a : unit.id; })) !== null && _a !== void 0 ? _a : [];
    var originalIds = new Set(originalIdsOrder);
    var result = updatedTranslationSourceFile
        .filter(function (n) { return originalIds.has(n.id); })
        .sort(function (a, b) {
        var indexA = originalIdsOrder.indexOf(a.id);
        var indexB = originalIdsOrder.indexOf(b.id);
        return indexA - indexB;
    });
    return {
        updatedTranslationSourceDoc: result,
        newUnits: updatedTranslationSourceFile.filter(function (n) { return !originalIds.has(n.id); })
    };
}
function resetSortOrderStableAppendNew(originalTranslationSourceFile, updatedTranslationSourceFile, idMapping) {
    var _a;
    var resetStable = resetSortOrderStable(originalTranslationSourceFile, updatedTranslationSourceFile, idMapping);
    var newUnitsSorted = resetStable.newUnits.sort(function (a, b) { return a.id.toLowerCase().localeCompare(b.id.toLowerCase()); });
    (_a = resetStable.updatedTranslationSourceDoc).push.apply(_a, newUnitsSorted);
    return resetStable.updatedTranslationSourceDoc;
}
function resetSortOrderStableAlphabetNew(originalTranslationSourceFile, updatedTranslationSourceFile, idMapping) {
    var resetStable = resetSortOrderStable(originalTranslationSourceFile, updatedTranslationSourceFile, idMapping);
    resetStable.newUnits
        .sort(function (a, b) { return a.id.toLowerCase().localeCompare(b.id.toLowerCase()); })
        .forEach(function (newUnit) {
        var _a = (0, lexUtils_1.findLexClosestIndex)(newUnit.id.toLowerCase(), resetStable.updatedTranslationSourceDoc, function (unit) { return unit.id.toLowerCase(); }), index = _a[0], before = _a[1];
        resetStable.updatedTranslationSourceDoc.splice(index + (before ? 0 : 1), 0, newUnit);
    });
    return resetStable.updatedTranslationSourceDoc;
}
function extractI18nMergeBuilder(options, context) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return __awaiter(this, void 0, void 0, function () {
        function fromXlf(input) {
            return (input !== undefined && input !== null) ? (isXliffV2 ? (0, translationFileSerialization_1.fromXlf2)(input) : (0, translationFileSerialization_1.fromXlf1)(input)) : undefined;
        }
        function toXlf(output) {
            var _a;
            var outputOptions = { prettyNestedTags: (_a = options.prettyNestedTags) !== null && _a !== void 0 ? _a : true };
            return isXliffV2 ? (0, translationFileSerialization_1.toXlf2)(output, outputOptions) : (0, translationFileSerialization_1.toXlf1)(output, outputOptions);
        }
        function filterUnits(unit) {
            var _a, _b;
            if ((_a = options.includeIdsWithPrefix) === null || _a === void 0 ? void 0 : _a.length) {
                return options.includeIdsWithPrefix.some(function (includePrefix) { return unit.id.startsWith(includePrefix); });
            }
            if (options.removeIdsWithPrefix) {
                return !((_b = options.removeIdsWithPrefix) === null || _b === void 0 ? void 0 : _b.some(function (removePrefix) { return unit.id.startsWith(removePrefix); }));
            }
            return true;
        }
        var outputPath, format, isXliffV2, initialTranslationState, sourcePath, translationSourceFileOriginal, _j, extractI18nRun, extractI18nResult, translationSourceFile, _k, sort, identityMapper, mapper, removeContextSource, normalizedTranslationSourceFile, merger, targetFilesSourceLangFirst, idsOfUnitsWithSourceChangedToSourceLangTarget, _loop_1, _i, targetFilesSourceLangFirst_1, targetFile, sortedTranslationSource;
        return __generator(this, function (_l) {
            switch (_l.label) {
                case 0:
                    context.logger.info("Running ng-extract-i18n-merge for project ".concat((_a = context.target) === null || _a === void 0 ? void 0 : _a.project));
                    if (!options.verbose) {
                        console.debug = function () { return null; }; // prevent debug output from xml_normalize and xliff-simple-merge
                    }
                    context.logger.debug("options: ".concat(JSON.stringify(options)));
                    outputPath = options.outputPath || '.';
                    format = options.format || 'xlf';
                    isXliffV2 = format.includes('2');
                    initialTranslationState = isXliffV2 ? STATE_INITIAL_XLF_2_0 : STATE_INITIAL_XLF_1_2;
                    context.logger.info('running "extract-i18n" ...');
                    sourcePath = (0, core_1.join)((0, core_1.normalize)(outputPath), (_b = options.sourceFile) !== null && _b !== void 0 ? _b : 'messages.xlf');
                    _j = fromXlf;
                    return [4 /*yield*/, (0, fileUtils_1.readFileIfExists)(sourcePath)];
                case 1:
                    translationSourceFileOriginal = _j.apply(void 0, [_l.sent()]);
                    return [4 /*yield*/, context.scheduleBuilder((_c = options.builderI18n) !== null && _c !== void 0 ? _c : '@angular-devkit/build-angular:extract-i18n', {
                            browserTarget: options.browserTarget,
                            outputPath: (0, core_1.dirname)(sourcePath),
                            outFile: (0, core_1.basename)(sourcePath),
                            format: format,
                            progress: false
                        }, { target: context.target, logger: context.logger.createChild('extract-i18n') })];
                case 2:
                    extractI18nRun = _l.sent();
                    return [4 /*yield*/, extractI18nRun.result];
                case 3:
                    extractI18nResult = _l.sent();
                    if (!extractI18nResult.success) {
                        return [2 /*return*/, { success: false, error: "\"extract-i18n\" failed: ".concat(extractI18nResult.error) }];
                    }
                    context.logger.info("extracted translations successfully");
                    context.logger.info("normalize ".concat(sourcePath, " ..."));
                    _k = fromXlf;
                    return [4 /*yield*/, fs_1.promises.readFile(sourcePath, 'utf8')];
                case 4:
                    translationSourceFile = _k.apply(void 0, [_l.sent()]);
                    sort = (_d = options.sort) !== null && _d !== void 0 ? _d : 'stableAppendNew';
                    identityMapper = function (x) { return x; };
                    mapper = pipe(((_e = options.collapseWhitespace) !== null && _e !== void 0 ? _e : true) ? stringUtils_1.doCollapseWhitespace : identityMapper, ((_f = options.trim) !== null && _f !== void 0 ? _f : false) ? function (text) { return text === null || text === void 0 ? void 0 : text.trim(); } : identityMapper);
                    removeContextSource = options.includeContext !== true && options.includeContext !== 'sourceFileOnly';
                    normalizedTranslationSourceFile = translationSourceFile.mapUnitsList(function (units) {
                        var updatedUnits = units
                            .filter(filterUnits)
                            .map(function (unit) { return (__assign(__assign({}, unit), { source: mapper(unit.source), target: unit.target !== undefined ? mapper(unit.target) : undefined, locations: removeContextSource ? [] : unit.locations, description: removeContextSource ? undefined : mapper(unit.description), meaning: removeContextSource ? undefined : mapper(unit.meaning) })); });
                        if (sort === 'idAsc') {
                            return updatedUnits.sort(function (a, b) { return a.id.localeCompare(b.id); });
                        }
                        return updatedUnits;
                    });
                    merger = new merger_1.Merger(options, normalizedTranslationSourceFile, initialTranslationState);
                    targetFilesSourceLangFirst = __spreadArray(__spreadArray([], options.targetFiles.filter(function (f) { return f === options.sourceLanguageTargetFile; }), true), options.targetFiles.filter(function (f) { return f !== options.sourceLanguageTargetFile; }), true);
                    idsOfUnitsWithSourceChangedToSourceLangTarget = new Set();
                    _loop_1 = function (targetFile) {
                        var targetPath, translationTargetFileContent, translationTargetFile, isSourceLang, mergedTarget, normalizedTarget;
                        return __generator(this, function (_m) {
                            switch (_m.label) {
                                case 0:
                                    targetPath = (0, core_1.join)((0, core_1.normalize)(outputPath), targetFile);
                                    context.logger.info("merge and normalize ".concat(targetPath, " ..."));
                                    return [4 /*yield*/, (0, fileUtils_1.readFileIfExists)(targetPath)];
                                case 1:
                                    translationTargetFileContent = _m.sent();
                                    translationTargetFile = translationTargetFileContent ? fromXlf(translationTargetFileContent) : new translationFileModels_1.TranslationFile([], translationSourceFile.sourceLang, (_h = (_g = targetPath === null || targetPath === void 0 ? void 0 : targetPath.match(/\.([a-zA-Z-]+)\.xlf$/)) === null || _g === void 0 ? void 0 : _g[1]) !== null && _h !== void 0 ? _h : 'en');
                                    isSourceLang = targetFile === options.sourceLanguageTargetFile;
                                    mergedTarget = merger.mergeWithMapping(translationTargetFile, isSourceLang);
                                    normalizedTarget = mergedTarget.mapUnitsList(function (units) {
                                        var updatedUnits = units
                                            .filter(filterUnits)
                                            .map(function (unit) {
                                            var _a, _b;
                                            return (__assign(__assign({}, unit), { source: mapper(unit.source), target: unit.target !== undefined ? mapper(unit.target) : undefined, locations: options.includeContext === true ? unit.locations : [], meaning: options.includeContext === true ? mapper(unit.meaning) : undefined, description: options.includeContext === true ? mapper(unit.description) : undefined, 
                                                // reset to original state, if source was changed to target from sourceLangTarget:
                                                state: idsOfUnitsWithSourceChangedToSourceLangTarget.has(unit.id) ? ((_b = (_a = translationTargetFile.units.find(function (u) { return u.id === unit.id; })) === null || _a === void 0 ? void 0 : _a.state) !== null && _b !== void 0 ? _b : unit.state) : unit.state }));
                                        });
                                        if (sort === 'idAsc') {
                                            updatedUnits.sort(function (a, b) { return a.id.localeCompare(b.id); });
                                        }
                                        else if (sort === 'stableAlphabetNew') {
                                            return resetSortOrderStableAlphabetNew((translationTargetFile === null || translationTargetFile === void 0 ? void 0 : translationTargetFile.units) || null, updatedUnits, merger.idMapping);
                                        }
                                        return updatedUnits;
                                    });
                                    if (isSourceLang) {
                                        normalizedTarget.units
                                            .filter(function (unit) { return unit.target !== undefined && unit.target !== unit.source; })
                                            .forEach(function (unit) { return context.logger.warn("Found manual changed target with id=".concat(unit.id, " in sourceLanguageTargetFile. Consider changing the source code occurrences from \"").concat(unit.source, "\" to \"").concat(unit.target, "\".")); });
                                        normalizedTarget.units
                                            .filter(function (unit) {
                                            var oldUnit = translationTargetFile.units.find(function (u) { return u.id === unit.id; });
                                            return unit.target !== undefined && unit.target === unit.source && (oldUnit === null || oldUnit === void 0 ? void 0 : oldUnit.source) !== (oldUnit === null || oldUnit === void 0 ? void 0 : oldUnit.target) && (oldUnit === null || oldUnit === void 0 ? void 0 : oldUnit.target) === unit.source;
                                        })
                                            .map(function (unit) { return unit.id; })
                                            .forEach(function (id) { return idsOfUnitsWithSourceChangedToSourceLangTarget.add(id); });
                                    }
                                    return [4 /*yield*/, fs_1.promises.writeFile(targetPath, toXlf(normalizedTarget))];
                                case 2:
                                    _m.sent();
                                    return [2 /*return*/];
                            }
                        });
                    };
                    _i = 0, targetFilesSourceLangFirst_1 = targetFilesSourceLangFirst;
                    _l.label = 5;
                case 5:
                    if (!(_i < targetFilesSourceLangFirst_1.length)) return [3 /*break*/, 8];
                    targetFile = targetFilesSourceLangFirst_1[_i];
                    return [5 /*yield**/, _loop_1(targetFile)];
                case 6:
                    _l.sent();
                    _l.label = 7;
                case 7:
                    _i++;
                    return [3 /*break*/, 5];
                case 8:
                    sortedTranslationSource = normalizedTranslationSourceFile.mapUnitsList(function (units) {
                        var _a, _b;
                        if (sort === 'stableAppendNew') {
                            return resetSortOrderStableAppendNew((_a = translationSourceFileOriginal === null || translationSourceFileOriginal === void 0 ? void 0 : translationSourceFileOriginal.units) !== null && _a !== void 0 ? _a : null, units, merger.idMapping);
                        }
                        else if (sort === 'stableAlphabetNew') {
                            return resetSortOrderStableAlphabetNew((_b = translationSourceFileOriginal === null || translationSourceFileOriginal === void 0 ? void 0 : translationSourceFileOriginal.units) !== null && _b !== void 0 ? _b : null, units, merger.idMapping);
                        }
                        else {
                            return units;
                        }
                    });
                    return [4 /*yield*/, fs_1.promises.writeFile(sourcePath, toXlf(sortedTranslationSource))];
                case 9:
                    _l.sent();
                    context.logger.info('finished i18n merging and normalizing');
                    return [2 /*return*/, { success: true }];
            }
        });
    });
}
var pipe = function () {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return fns.reduce(function (prevFn, nextFn) { return function (value) { return nextFn(prevFn(value)); }; }, function (x) { return x; });
};
