"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findLexClosestIndex = exports.LexDist = void 0;
var LexDist = /** @class */ (function () {
    function LexDist(dist) {
        this.dist = dist;
    }
    LexDist.prototype.isNegative = function () {
        var _a;
        return ((_a = this.dist.find(function (d) { return d !== 0; })) !== null && _a !== void 0 ? _a : 0) < 0;
    };
    LexDist.prototype.smallerThan = function (other) {
        var _a, _b, _c, _d, _e, _f;
        var firstSignThis = 0;
        var firstSignOther = 0;
        for (var i = 0; i < Math.max(this.dist.length, other.dist.length); i++) {
            if (firstSignThis === 0) {
                firstSignThis = Math.sign((_a = this.dist[i]) !== null && _a !== void 0 ? _a : 0);
            }
            if (firstSignOther === 0) {
                firstSignOther = Math.sign((_b = other.dist[i]) !== null && _b !== void 0 ? _b : 0);
            }
            var thisDistI = firstSignThis ? firstSignThis * ((_c = this.dist[i]) !== null && _c !== void 0 ? _c : 0) : ((_d = this.dist[i]) !== null && _d !== void 0 ? _d : 0);
            var otherDistI = firstSignOther ? firstSignOther * ((_e = other.dist[i]) !== null && _e !== void 0 ? _e : 0) : ((_f = other.dist[i]) !== null && _f !== void 0 ? _f : 0);
            if (thisDistI < otherDistI) {
                return true;
            }
            else if (thisDistI > otherDistI) {
                return false;
            }
        }
        return false;
    };
    /**
     * "b - a"
     */
    LexDist.fromDifference = function (a, b) {
        var dist = [];
        for (var i = 0; i < a.length || i < b.length; i++) {
            dist.push((b.charCodeAt(i) || 0) - (a.charCodeAt(i) || 0));
        }
        return new LexDist(dist);
    };
    LexDist.prototype.normalize = function () {
        var dist = __spreadArray([], this.dist, true);
        while (dist.length > 0 && dist[dist.length - 1] === 0) {
            dist.pop();
        }
        return new LexDist(dist);
    };
    return LexDist;
}());
exports.LexDist = LexDist;
var DIST_MAX = new LexDist([Number.MAX_SAFE_INTEGER]);
function findLexClosestIndex(id, units, mapping) {
    // defaults work with empty list:
    var index = 0;
    var minDistance = DIST_MAX;
    for (var i = 0; i < units.length; i++) {
        var idNormalized = id.toLowerCase();
        var distance = LexDist.fromDifference(idNormalized, mapping(units[i]).toLowerCase());
        if (distance.smallerThan(minDistance)) {
            minDistance = distance;
            index = i;
        }
    }
    return [index, !minDistance.isNegative()];
}
exports.findLexClosestIndex = findLexClosestIndex;
